/*
	written for mySQL 3.23.49 max nt
	by Louis Solomon / www.SteelBytes.com
	18/Oct/2002 - 31/Oct/2002
	17/April/2003  change the SQL code to use INSERT key,0 then UPDATE key,data+=val  instead of LOCK,COUNT,...
*/

#pragma warning (disable:4100) // unreferenced formal parameter
#pragma warning (disable:4127) // conditional expression is constant
#pragma warning (disable:4164) // intrinsic function not declared
#pragma warning (disable:4201) // nonstandard extension used : nameless struct/union
#pragma warning (disable:4206) // nonstandard extension used : translation unit is empty
#pragma warning (disable:4514) // unreferenced inline function has been removed

#define STRSAFE_LIB

#define STRICT
#define VC_EXTRALEAN
#define WIN32_LEAN_AND_MEAN

//#if defined(_PREFAST_)
//// because of MS's fuck ups causing CRT to clash with PlatformSDK in VS2005Beta2
//#define _FORCE_SPECSTRINGS_DECLSPECS
//#include "C:\Program Files\Microsoft Platform SDK\Include\specstrings.h"
//#endif

/*lint -save -e* */
#include <windows.h>
#include <sql.h>
#include <sqlext.h>
//#include <odbcss.h>
#include <strsafe.h>
/*lint -restore */
#include <stdlib.h>

#pragma hdrstop

#ifndef _DEBUG
#pragma check_stack(off)
#pragma runtime_checks( "", off )
#endif

#pragma intrinsic(memset)
#pragma intrinsic(memcmp)
#pragma intrinsic(memcpy)
//#pragma intrinsic(strcpy)
#pragma intrinsic(strcmp)
#ifdef __cplusplus
extern "C" {
#endif
#undef RtlCopyMemory
#undef RtlZeroMemory
#undef RtlMoveMemory
NTSYSAPI VOID NTAPI RtlMoveMemory (VOID UNALIGNED *Destination,CONST VOID UNALIGNED *Source,SIZE_T Length);
NTSYSAPI VOID NTAPI RtlZeroMemory (VOID UNALIGNED *Destination,SIZE_T Length);
#define RtlCopyMemory RtlMoveMemory
#ifdef __cplusplus
}
#endif

#define STRING_LENGTH(s) (sizeof(s)/sizeof((s)[0]))
#include "ptinterface.h"

#pragma comment(linker,"/EXPORT:PTI_HttpLog_Start=_PTI_HttpLog_Start@4")
#pragma comment(linker,"/EXPORT:PTI_HttpLog_End=_PTI_HttpLog_End@4")
#pragma comment(linker,"/EXPORT:PTI_HttpLog_Hit=_PTI_HttpLog_Hit@4")

static SQLHENV henv = SQL_NULL_HENV;
static SQLHDBC hdbc1 = SQL_NULL_HDBC;
static LONG refcount = 0;

static int my_memicmp(const void * first,const void * last,unsigned int count)
{
    int f = 0;
    int l = 0;
    while ( count-- )
    {
        if ( (*(unsigned char *)first == *(unsigned char *)last) ||
            ((f = (int)CharLower( (char *) (*(unsigned char *)first) )) ==
            (l = (int)CharLower( (char *) (*(unsigned char *)last) ))) )
        {
            first = (char *)first + 1;
            last = (char *)last + 1;
        }
        else
            break;
    }
    return ( f - l );
}

static bool SQLisOK(SQLRETURN code)
{
	return (code==SQL_SUCCESS || code==SQL_SUCCESS_WITH_INFO);
}

static void DB_done(void)
{
	if (InterlockedDecrement(&refcount)==0)
	{
		if (henv!=SQL_NULL_HENV)
		{
			if (hdbc1!=SQL_NULL_HDBC)
			{
				SQLDisconnect(hdbc1);
				SQLFreeHandle(SQL_HANDLE_DBC, hdbc1);
				hdbc1 = SQL_NULL_HDBC;
			}
			SQLFreeHandle(SQL_HANDLE_ENV, henv);
			henv = SQL_NULL_HENV;
		}
	}
}

static void DB_init(void)
{
	InterlockedIncrement(&refcount);
	if (SQLisOK(SQLAllocHandle(SQL_HANDLE_ENV, NULL, &henv)) && SQLisOK(SQLSetEnvAttr(henv, SQL_ATTR_ODBC_VERSION,(SQLPOINTER) SQL_OV_ODBC3, SQL_IS_INTEGER)))
	{
		if (SQLisOK(SQLAllocHandle(SQL_HANDLE_DBC, henv, &hdbc1)))
		{
			char filename[MAX_PATH];
			GetModuleFileName(GetModuleHandle("pti_httplog"),filename,sizeof(filename));
			char *p = filename+lstrlen(filename);
			while (p>filename && *p!='.')
				p--;
			*p = 0;
			StringCchCat(filename,STRING_LENGTH(filename),".INI");
			char dsn_name[256];
			char dsn_user[256];
			char dsn_pass[256];
			GetPrivateProfileString("ODBC-DSN","Name","",dsn_name,sizeof(dsn_name),filename);
			GetPrivateProfileString("ODBC-DSN","User","",dsn_user,sizeof(dsn_user),filename);
			GetPrivateProfileString("ODBC-DSN","Pass","",dsn_pass,sizeof(dsn_pass),filename);
			if (SQLisOK(SQLConnect(hdbc1,(SQLCHAR*)dsn_name, SQL_NTS, (SQLCHAR*)dsn_user, SQL_NTS,(SQLCHAR*)dsn_pass, SQL_NTS)))
			{
			}
			else
			{
				DB_done();
			}
		}
	}
}

static bool DB_DoQuery(SQLHSTMT hstmt1,const char *query,SQLSMALLINT *num_results_returned=NULL,SQLINTEGER *data=NULL)
{
	bool result = false;
	if (num_results_returned)
		*num_results_returned = 0;
	if (SQLisOK(SQLExecDirect(hstmt1,(SQLCHAR*)query,SQL_NTS)))
	{
		if (num_results_returned)
		{
			SQLNumResultCols(hstmt1,num_results_returned);
			if (((*num_results_returned)>0) && (data!=NULL))
			{
				if (SQLisOK(SQLFetch(hstmt1)))
				{
					SQLGetData(hstmt1,1,SQL_C_SLONG,data,sizeof(*data),NULL);
				}
			}
		}
		SQLCloseCursor(hstmt1);

		result = true;
	}
#ifdef _DEBUG
	else
	{
		char s[4096];
		StringCchPrintf(s,STRING_LENGTH(s),"The following SQL failed: %s\r\n",query);	
		OutputDebugString(s);
	}
#endif
	return result;
}

/*lint -e{818} */
void PTI_API PTI_HttpLog_Start(PTI_HTTPLOG_START *httplog_start)
{
	DB_init();
	if (hdbc1==SQL_NULL_HDBC)
		return;

	SQLHSTMT hstmt1 = SQL_NULL_HSTMT;
	if (SQLisOK(SQLAllocHandle(SQL_HANDLE_STMT, hdbc1, &hstmt1)))
	{
		char *query = (char *)malloc(4096);
		if (query)
		{
			StringCchPrintf(query,4096,
				"CREATE TABLE IF NOT EXISTS `hits_%s` (host varchar(250) NOT NULL default '',url varchar(250) NOT NULL default '',hits BIGINT UNSIGNED,datetime datetime,PRIMARY KEY (host,url))",
				httplog_start->mapping_name);
			DB_DoQuery(hstmt1,query);
			free(query);
		}	
		SQLFreeHandle(SQL_HANDLE_STMT, hstmt1);
	}
}

/*lint -e{818} */
int PTI_API PTI_HttpLog_Hit(PTI_HTTPLOG_HIT *httplog_hit)
{
	int res = -1;
	if (hdbc1!=SQL_NULL_HDBC)
	{
		SQLHSTMT hstmt1 = SQL_NULL_HSTMT;
		if (SQLisOK(SQLAllocHandle(SQL_HANDLE_STMT, hdbc1, &hstmt1)))
		{
			char *_url = (char *)malloc(4096);
			if (_url)
			{
				{
					char *q = _url;
					char *q_end = _url+4096-2; // -2 to allow room for NULL term and an extra \ before special chars
					const char *p = httplog_hit->request_line;
					// skip GET/POST
					while (*p && *p!=' ') p++;
					while (*p && *p==' ') p++;
					// get URL
					while (q<q_end)
					{
						char c = *p++;
						if (!c || c==' ' || c=='?')
							break;
						if (c=='\'' || c=='\\' || c<' ')
							*q++ = '\\';
						*q++ = c;
					}
					*q = 0;
				}
				const char *url = _url;
				const char *host = httplog_hit->header_host;
				char host_extact[256];
				if (my_memicmp(_url,"http://",7)==0)
				{
					if (httplog_hit->header_host[0])
					{
						int host_header_len = lstrlen(host);
						if (my_memicmp(_url+7,httplog_hit->header_host,(size_t)host_header_len)==0)
							url = _url+7+host_header_len;
					}
					else
					{
						url = _url+7;
						host = host_extact;
						char *p = host_extact;
						char *p_end = host_extact+sizeof(host_extact)-1;
						while (1)
						{
							char c = *url;
							if (c=='/')
								break;
							if (p<p_end)
								*p++ = c;
							url++;
						}
						*p = 0;
					}
				}

				char *query = (char *)malloc(4096);
				if (query)
				{
					char *p;

					p = query;
					StringCchPrintf(p,4096-(size_t)(p-query),
						"INSERT `hits_%s` SET datetime=NOW(), url='%s', hits=0",
						httplog_hit->mapping_name,url);
					p += lstrlen(p);
					if (host[0])
					{
						StringCchPrintf(p,4096-(size_t)(p-query),
							", host='%s'",
							host);
						p += lstrlen(p);
					}
					DB_DoQuery(hstmt1,query);

					p = query;
					StringCchPrintf(p,4096-(size_t)(p-query),
						"UPDATE `hits_%s` SET datetime=NOW(), hits=hits+1 WHERE url='%s'",
						httplog_hit->mapping_name,url);
					p += lstrlen(p);
					if (host[0])
					{
						StringCchPrintf(p,4096-(size_t)(p-query),
							" AND host='%s'",
							host);
						p += lstrlen(p);
					}
					if (DB_DoQuery(hstmt1,query))
					{
						res = 0;
					}

					free(query);
				}
				free(_url);
			}
			SQLFreeHandle(SQL_HANDLE_STMT, hstmt1);
		}
	}
	return res;
}

/*lint -e{715,818} */
void PTI_API PTI_HttpLog_End(PTI_HTTPLOG_END *httplog_end)
{
	DB_done();
}

/*lint -e{715,818} */
BOOL WINAPI DllMain(HINSTANCE hinstDLL,DWORD fdwReason,LPVOID lpvReserved)
{
	return 1;
}
