/*
	written for mySQL 3.23.49 max nt
	by Louis Solomon / www.SteelBytes.com
	18/Oct/2002 - 31/Oct/2002
	17/April/2003  change the SQL code to use INSERT key,0 then UPDATE key,data+=val  instead of LOCK,COUNT,...
*/

#pragma warning (disable:4100) // unreferenced formal parameter
#pragma warning (disable:4127) // conditional expression is constant
#pragma warning (disable:4164) // intrinsic function not declared
#pragma warning (disable:4201) // nonstandard extension used : nameless struct/union
#pragma warning (disable:4206) // nonstandard extension used : translation unit is empty
#pragma warning (disable:4514) // unreferenced inline function has been removed

#define STRSAFE_LIB

#define STRICT
#define VC_EXTRALEAN
#define WIN32_LEAN_AND_MEAN

//#if defined(_PREFAST_)
//// because of MS's fuck ups causing CRT to clash with PlatformSDK in VS2005Beta2
//#define _FORCE_SPECSTRINGS_DECLSPECS
//#include "C:\Program Files\Microsoft Platform SDK\Include\specstrings.h"
//#endif

/*lint -save -e* */
#include <windows.h>
#include <sql.h>
#include <sqlext.h>
#include <strsafe.h>
#include <Winsock2.h>
/*lint -restore */
#include <stdlib.h>

#pragma hdrstop

#ifndef _DEBUG
#pragma check_stack(off)
#pragma runtime_checks( "", off )
#endif

#pragma intrinsic(memset)
#pragma intrinsic(memcmp)
#pragma intrinsic(memcpy)
//#pragma intrinsic(strcpy)
#pragma intrinsic(strcmp)
#ifdef __cplusplus
extern "C" {
#endif
#undef RtlCopyMemory
#undef RtlZeroMemory
#undef RtlMoveMemory
NTSYSAPI VOID NTAPI RtlMoveMemory (VOID UNALIGNED *Destination,CONST VOID UNALIGNED *Source,SIZE_T Length);
NTSYSAPI VOID NTAPI RtlZeroMemory (VOID UNALIGNED *Destination,SIZE_T Length);
#define RtlCopyMemory RtlMoveMemory
#ifdef __cplusplus
}
#endif

#define STRING_LENGTH(s) (sizeof(s)/sizeof((s)[0]))
#include "ptinterface.h"

#pragma comment(linker,"/EXPORT:PTI_StatsEvent_Start=_PTI_StatsEvent_Start@4")
#pragma comment(linker,"/EXPORT:PTI_StatsEvent_End=_PTI_StatsEvent_End@4")
#pragma comment(linker,"/EXPORT:PTI_StatsEvent_Event=_PTI_StatsEvent_Event@4")

static SQLHENV henv = SQL_NULL_HENV;
static SQLHDBC hdbc1 = SQL_NULL_HDBC;
static LONG refcount = 0;

static bool SQLisOK(SQLRETURN code)
{
	return (code==SQL_SUCCESS || code==SQL_SUCCESS_WITH_INFO);
}

static void DB_done(void)
{
	if (InterlockedDecrement(&refcount)==0)
	{
		if (henv!=SQL_NULL_HENV)
		{
			if (hdbc1!=SQL_NULL_HDBC)
			{
				SQLDisconnect(hdbc1);
				SQLFreeHandle(SQL_HANDLE_DBC, hdbc1);
				hdbc1 = SQL_NULL_HDBC;
			}
			SQLFreeHandle(SQL_HANDLE_ENV, henv);
			henv = SQL_NULL_HENV;
		}
	}
}

static void DB_init(void)
{
	InterlockedIncrement(&refcount);
	if (SQLisOK(SQLAllocHandle(SQL_HANDLE_ENV, NULL, &henv)) && SQLisOK(SQLSetEnvAttr(henv, SQL_ATTR_ODBC_VERSION,(SQLPOINTER) SQL_OV_ODBC3, SQL_IS_INTEGER)))
	{
		if (SQLisOK(SQLAllocHandle(SQL_HANDLE_DBC, henv, &hdbc1)))
		{
			char filename[MAX_PATH];
			GetModuleFileName(GetModuleHandle("pti_statsevent"),filename,sizeof(filename));
			char *p = filename+lstrlen(filename);
			while (p>filename && *p!='.')
				p--;
			*p = 0;
			StringCchCat(filename,STRING_LENGTH(filename),".INI");
			char dsn_name[256];
			char dsn_user[256];
			char dsn_pass[256];
			GetPrivateProfileString("ODBC-DSN","Name","",dsn_name,sizeof(dsn_name),filename);
			GetPrivateProfileString("ODBC-DSN","User","",dsn_user,sizeof(dsn_user),filename);
			GetPrivateProfileString("ODBC-DSN","Pass","",dsn_pass,sizeof(dsn_pass),filename);
			if (SQLisOK(SQLConnect(hdbc1,(SQLCHAR*)dsn_name, SQL_NTS, (SQLCHAR*)dsn_user, SQL_NTS,(SQLCHAR*)dsn_pass, SQL_NTS)))
			{
			}
			else
			{
				DB_done();
			}
		}
	}
}

static bool DB_DoQuery(SQLHSTMT hstmt1,const char *query,SQLSMALLINT *num_results_returned=NULL,SQLINTEGER *data=NULL)
{
	bool result = false;
	if (num_results_returned)
		*num_results_returned = 0;

	if (SQLisOK(SQLExecDirect(hstmt1,(SQLCHAR*)query,SQL_NTS)))
	{
		if (num_results_returned)
		{
			SQLNumResultCols(hstmt1,num_results_returned);
			if (((*num_results_returned)>0) && (data!=NULL))
			{
				if (SQLisOK(SQLFetch(hstmt1)))
				{
					SQLGetData(hstmt1,1,SQL_C_SLONG,data,sizeof(*data),NULL);
				}
			}
		}
		SQLCloseCursor(hstmt1);

		result = true;
	}
#ifdef _DEBUG
	else
	{
		char s[4096];
		StringCchPrintf(s,STRING_LENGTH(s),"The following SQL failed: %s\r\n",query);	
		OutputDebugString(s);
	}
#endif
	return result;
}

/*lint -e{818} */
void PTI_API PTI_StatsEvent_Start(PTI_STATSEVENT_START *statsevent_start)
{
	DB_init();
	if (hdbc1==SQL_NULL_HDBC)
		return;

	SQLHSTMT hstmt1 = SQL_NULL_HSTMT;
	if (SQLisOK(SQLAllocHandle(SQL_HANDLE_STMT, hdbc1, &hstmt1)))
	{
		char *query = (char *)malloc(4096);
		if (query)
		{
			StringCchPrintf(query,4096,
				"CREATE TABLE IF NOT EXISTS `stats_%s` (clientip varchar(250) NOT NULL default '',date date NOT NULL default '0000-00-00',connects int(11) default NULL,bytesin bigint(20) default NULL,bytesout bigint(20) default NULL,PRIMARY KEY (clientip,date))",
				statsevent_start->mapping_name);
			DB_DoQuery(hstmt1,query);
			free(query);
		}
		SQLFreeHandle(SQL_HANDLE_STMT, hstmt1);
	}
}

/*lint -e{818} */
void PTI_API PTI_StatsEvent_Event(PTI_STATSEVENT_EVENT *statsevent_event)
{
	if (hdbc1==SQL_NULL_HDBC)
		return;
	if (statsevent_event->event_id==PTISE_CONNECT || statsevent_event->event_id==PTISE_BYTESINOUT)
	{
		SQLHSTMT hstmt1 = SQL_NULL_HSTMT;
		if (SQLisOK(SQLAllocHandle(SQL_HANDLE_STMT, hdbc1, &hstmt1)))
		{
			char *query = (char *)malloc(4096);
			if (query)
			{
				DWORD ip = htonl(statsevent_event->clientip);
				HOSTENT *hostent_ = gethostbyaddr((const char *)&ip,4,AF_INET);
				char *ip_string;
				char ip_string_buf[32];
				if (hostent_)
				{
					ip_string = hostent_->h_name;
				}
				else
				{
					ip_string = ip_string_buf;
					StringCchPrintf(ip_string_buf,STRING_LENGTH(ip_string_buf),"%i.%i.%i.%i",(BYTE)(ip>>0),(BYTE)(ip>>8),(BYTE)(ip>>16),(BYTE)(ip>>24));
				}

				char datestr[32];
				SYSTEMTIME thetime;
				GetLocalTime(&thetime);
				StringCchPrintf(datestr,STRING_LENGTH(datestr),"%i-%i-%i",thetime.wYear,thetime.wMonth,thetime.wDay);

				StringCchPrintf(query,4096,
					"INSERT `stats_%s` SET clientip='%s', date='%s', connects=0, bytesin=0, bytesout=0",
					statsevent_event->mapping_name,ip_string,datestr);
				DB_DoQuery(hstmt1,query);

				char *p = query;
				StringCchPrintf(p,4096-(size_t)(p-query),
					"UPDATE `stats_%s` SET ",
					statsevent_event->mapping_name);
				p += lstrlen(p);

				switch (statsevent_event->event_id)
				{
				case PTISE_CONNECT:
					StringCchPrintf(p,4096-(size_t)(p-query),"connects=connects+1");
					p += lstrlen(p);
					break;
				case PTISE_BYTESINOUT:
					StringCchPrintf(p,4096-(size_t)(p-query),
						"bytesin=bytesin+%I64i, bytesout=bytesout+%I64i",
						statsevent_event->bytesinout.bytesin,statsevent_event->bytesinout.bytesout);
					p += lstrlen(p);
					break;
				}

				StringCchPrintf(p,4096-(size_t)(p-query),
					" WHERE clientip='%s' AND date='%s'",
					ip_string,datestr);
				p += lstrlen(p);

				DB_DoQuery(hstmt1,query);
				free(query);
			}
			SQLFreeHandle(SQL_HANDLE_STMT, hstmt1);
		}
	}
}

/*lint -e{715,818} */
void PTI_API PTI_StatsEvent_End(PTI_STATSEVENT_END *statsevent_end)
{
	DB_done();
}

/*lint -e{715,818} */
BOOL WINAPI DllMain(HINSTANCE hinstDLL,DWORD fdwReason,LPVOID lpvReserved)
{
	return 1;
}
