#ifndef __PTINTERFACE_H__
#define __PTINTERFACE_H__
#pragma once
#pragma pack(push,4)
#ifdef __cplusplus
extern "C" {
#endif
#define PTI_API __stdcall


// HTTPLOG

typedef struct {
	DWORD size;
	const char *mapping_name;
	const char *params;
	void *userdata;
	WORD portin;
	WORD portin2;
} PTI_HTTPLOG_START;
void PTI_API PTI_HttpLog_Start(PTI_HTTPLOG_START *httplog_start);

typedef struct {
	DWORD size;
	const char *mapping_name;
	void *userdata;
} PTI_HTTPLOG_END;
void PTI_API PTI_HttpLog_End(PTI_HTTPLOG_END *httplog_end);

typedef struct {
	DWORD size;
	const char *mapping_name;
	const char *request_line;
	const char *reply_line;
	const char *header_host;
	DWORD client_ip;
	int length_in; // of body.  ie, not including the http header
	int length_out; // of body.  ie, not including the http header
	void *userdata;
} PTI_HTTPLOG_HIT;
int PTI_API PTI_HttpLog_Hit(PTI_HTTPLOG_HIT *httplog_hit); // return 0 for success


// STATSEVENT

typedef struct {
	DWORD size;
	const char *mapping_name;
	const char *params;
	void *userdata;
} PTI_STATSEVENT_START;
void PTI_API PTI_StatsEvent_Start(PTI_STATSEVENT_START *statsevent_start);

typedef struct {
	DWORD size;
	const char *mapping_name;
	void *userdata;
} PTI_STATSEVENT_END;
void PTI_API PTI_StatsEvent_End(PTI_STATSEVENT_END *statsevent_end);

enum {PTISE_CONNECT=1,PTISE_REJECT=2,PTISE_DISCONNECT=3,PTISE_BYTESINOUT=4};
typedef struct {
	DWORD size;
	const char *mapping_name;
	DWORD clientip;
	int event_id;
	union {
		struct {
			char dummy;
		} connect;
		struct {
			char dummy;
		} reject;
		struct {
		} disconnect;
			char dummy;
		struct {
			__int64 bytesin;
			__int64 bytesout;
		} bytesinout;
	};
	void *userdata;
} PTI_STATSEVENT_EVENT;
void PTI_API PTI_StatsEvent_Event(PTI_STATSEVENT_EVENT *statsevent_event);


#ifdef __cplusplus
}
#endif
#pragma pack(pop)
#endif
